/*
  Copyright Red Hat, Inc. 2008

  This program is free software; you can redistribute it and/or modify it
  under the terms of the GNU General Public License as published by the
  Free Software Foundation; version 2.

  This program is distributed in the hope that it will be useful, but
  WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; see the file COPYING.  If not, write to the
  Free Software Foundation, Inc.,  675 Mass Ave, Cambridge, 
  MA 02139, USA.
*/
#ifndef _METADATA_H
#define _METADATA_H

typedef struct {
	char *d_lang;
	char *d_shortdesc;
	char *d_longdesc;
} ra_desc_t;

#define RA_DESC_END {NULL, NULL, NULL}

typedef struct {
	char *h_version_minor;
	char *h_version_major;
	char *h_name;
	char *h_provider_version;
} ra_header_t;

typedef enum {
	RA_FL_UNIQUE=0x1,
	RA_FL_PRIMARY=0x2,
	RA_FL_REQUIRED=0x4
} ra_flags_t;

typedef struct {
	char *param_name;
	char *param_inherit;
	ra_desc_t *param_descs;
	char *param_content_type;
	char *param_default;
	ra_flags_t param_flags;
	int pad;
} ra_param_t;

#define RA_PARAM_END {NULL, NULL, NULL, NULL, NULL, 0, 0}

typedef struct {
	char *a_name;
	char *a_timeout;
	char *a_interval;
	char *a_depth;
} ra_act_t;

#define RA_ACT_END {NULL, NULL, NULL, NULL}


typedef struct {
	ra_header_t *ra_header;
	ra_desc_t *ra_desc;
	ra_param_t *ra_params;
	ra_act_t *ra_acts;
} ra_info_t;

void xml_print_metadata(ra_info_t *agent) ;
int get_param(ra_info_t *ra, const char *name, char *buf, size_t buflen);

#endif
